Index: code/branches/hud/src/orxonox/OrxonoxStableHeaders.h
===================================================================
--- code/branches/hud/src/orxonox/OrxonoxStableHeaders.h	(revision 1615)
+++ code/branches/hud/src/orxonox/OrxonoxStableHeaders.h	(revision 1616)
@@ -37,5 +37,5 @@
 #include "util/OrxonoxPlatform.h"
 
-#if ORXONOX_COMPILER == ORXONOX_COMPILER_MSVC
+#if ORXONOX_COMPILER == ORXONOX_COMPILER_MSVC && 0
 
 // including std headers here is useless since they're already precompiled
Index: code/branches/hud/src/orxonox/Radar.cc
===================================================================
--- code/branches/hud/src/orxonox/Radar.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/Radar.cc	(revision 1616)
@@ -38,6 +38,6 @@
 #include "objects/SpaceShip.h"
 #include "core/CoreIncludes.h"
+#include "core/ConsoleCommand.h"
 #include "RadarListener.h"
-//#include "core/ConfigValueIncludes.h"
 
 namespace orxonox
Index: code/branches/hud/src/orxonox/RadarListener.cc
===================================================================
--- code/branches/hud/src/orxonox/RadarListener.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/RadarListener.cc	(revision 1616)
@@ -29,4 +29,5 @@
 #include "OrxonoxStableHeaders.h"
 #include "RadarListener.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox
Index: code/branches/hud/src/orxonox/RadarViewable.cc
===================================================================
--- code/branches/hud/src/orxonox/RadarViewable.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/RadarViewable.cc	(revision 1616)
@@ -30,4 +30,6 @@
 #include "RadarViewable.h"
 #include "core/Debug.h"
+#include "core/CoreIncludes.h"
+#include "objects/WorldEntity.h"
 #include "Radar.h"
 
@@ -57,3 +59,15 @@
         this->radarObjectDescription_ = str;
     }
+
+    const Vector3& RadarViewable::getWorldPosition() const
+    {
+        validate();
+        return this->radarObject_->getWorldPosition();
+    }
+
+    Vector3 RadarViewable::getOrientedVelocity() const
+    {
+        validate();
+        return this->radarObject_->getOrientation() * this->radarObject_->getVelocity();
+    }
 }
Index: code/branches/hud/src/orxonox/RadarViewable.h
===================================================================
--- code/branches/hud/src/orxonox/RadarViewable.h	(revision 1615)
+++ code/branches/hud/src/orxonox/RadarViewable.h	(revision 1616)
@@ -32,6 +32,7 @@
 #include "OrxonoxPrereqs.h"
 #include <string>
+#include "util/Math.h"
+#include "core/Debug.h"
 #include "core/OrxonoxClass.h"
-#include "util/Math.h"
 
 namespace orxonox
@@ -64,7 +65,6 @@
 
         const WorldEntity* getWorldEntity() const { return this->radarObject_; }
-        const Vector3& getWorldPosition() const { validate(); return this->radarObject_->getWorldPosition(); }
-        Vector3 getOrientedVelocity() const
-            { validate(); return this->radarObject_->getOrientation() * this->radarObject_->getVelocity(); }
+        const Vector3& getWorldPosition() const;
+        Vector3 getOrientedVelocity() const;
 
         Shape getRadarObjectType() const { return this->radarObjectType_; }
Index: code/branches/hud/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 1616)
@@ -36,4 +36,6 @@
 #include "util/String.h"
 #include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+#include "core/ConsoleCommand.h"
 #include "GraphicsEngine.h"
 
Index: code/branches/hud/src/orxonox/overlays/OverlayGroup.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/OverlayGroup.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/OverlayGroup.cc	(revision 1616)
@@ -33,4 +33,5 @@
 #include "core/ConsoleCommand.h"
 #include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
 #include "OrxonoxOverlay.h"
 
Index: code/branches/hud/src/orxonox/overlays/OverlayText.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/OverlayText.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/OverlayText.cc	(revision 1616)
@@ -36,4 +36,6 @@
 #include "util/Convert.h"
 #include "util/String.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/hud/src/orxonox/overlays/hud/HUDBar.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDBar.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDBar.cc	(revision 1616)
@@ -38,4 +38,6 @@
 
 #include "util/Convert.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
 
 namespace orxonox
Index: code/branches/hud/src/orxonox/overlays/hud/HUDFPSText.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDFPSText.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDFPSText.cc	(revision 1616)
@@ -30,4 +30,5 @@
 #include "HUDFPSText.h"
 #include <OgreTextAreaOverlayElement.h>
+#include "core/CoreIncludes.h"
 #include "GraphicsEngine.h"
 #include "util/Convert.h"
Index: code/branches/hud/src/orxonox/overlays/hud/HUDFPSText.h
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDFPSText.h	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDFPSText.h	(revision 1616)
@@ -33,4 +33,5 @@
 
 #include "overlays/OverlayText.h"
+#include "objects/Tickable.h"
 
 namespace orxonox
Index: code/branches/hud/src/orxonox/overlays/hud/HUDNavigation.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDNavigation.cc	(revision 1616)
@@ -36,5 +36,8 @@
 #include "util/Math.h"
 #include "util/String.h"
+#include "util/Convert.h"
 #include "core/ConsoleCommand.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
 #include "objects/SpaceShip.h"
 #include "objects/Projectile.h"
Index: code/branches/hud/src/orxonox/overlays/hud/HUDNavigation.h
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDNavigation.h	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDNavigation.h	(revision 1616)
@@ -34,4 +34,5 @@
 #include <OgrePrerequisites.h>
 #include "overlays/OrxonoxOverlay.h"
+#include "objects/Tickable.h"
 
 namespace orxonox
Index: code/branches/hud/src/orxonox/overlays/hud/HUDRTRText.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDRTRText.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDRTRText.cc	(revision 1616)
@@ -30,6 +30,7 @@
 #include "HUDRTRText.h"
 #include <OgreTextAreaOverlayElement.h>
+#include "core/CoreIncludes.h"
+#include "util/Convert.h"
 #include "GraphicsEngine.h"
-#include "util/Convert.h"
 
 namespace orxonox
Index: code/branches/hud/src/orxonox/overlays/hud/HUDRTRText.h
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDRTRText.h	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDRTRText.h	(revision 1616)
@@ -33,4 +33,5 @@
 
 #include "overlays/OverlayText.h"
+#include "objects/Tickable.h"
 
 namespace orxonox
Index: code/branches/hud/src/orxonox/overlays/hud/HUDRadar.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDRadar.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDRadar.cc	(revision 1616)
@@ -36,4 +36,6 @@
 #include "util/Math.h"
 #include "core/ConsoleCommand.h"
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
 #include "objects/SpaceShip.h"
 #include "objects/WorldEntity.h"
Index: code/branches/hud/src/orxonox/overlays/hud/HUDSpeedBar.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDSpeedBar.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDSpeedBar.cc	(revision 1616)
@@ -30,4 +30,5 @@
 #include "OrxonoxStableHeaders.h"
 #include "HUDSpeedBar.h"
+#include "core/CoreIncludes.h"
 #include "objects/SpaceShip.h"
 
Index: code/branches/hud/src/orxonox/overlays/hud/HUDSpeedBar.h
===================================================================
--- code/branches/hud/src/orxonox/overlays/hud/HUDSpeedBar.h	(revision 1615)
+++ code/branches/hud/src/orxonox/overlays/hud/HUDSpeedBar.h	(revision 1616)
@@ -34,4 +34,5 @@
 
 #include "HUDBar.h"
+#include "objects/Tickable.h"
 
 namespace orxonox
Index: code/branches/hud/src/orxonox/tools/WindowEventListener.cc
===================================================================
--- code/branches/hud/src/orxonox/tools/WindowEventListener.cc	(revision 1615)
+++ code/branches/hud/src/orxonox/tools/WindowEventListener.cc	(revision 1616)
@@ -29,4 +29,5 @@
 #include "OrxonoxStableHeaders.h"
 #include "WindowEventListener.h"
+#include "core/CoreIncludes.h"
 
 namespace orxonox