Index: code/branches/hud/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/hud/src/orxonox/CMakeLists.txt	(revision 1618)
+++ code/branches/hud/src/orxonox/CMakeLists.txt	(revision 1619)
@@ -14,9 +14,10 @@
   overlays/console/InGameConsole.cc
 
+  overlays/debug/DebugFPSText.cc
+  overlays/debug/DebugRTRText.cc
+
   overlays/hud/HUDBar.cc
-  overlays/hud/HUDFPSText.cc
   overlays/hud/HUDNavigation.cc
   overlays/hud/HUDRadar.cc
-  overlays/hud/HUDRTRText.cc
   overlays/hud/HUDSpeedBar.cc
 
Index: code/branches/hud/src/orxonox/overlays/debug/DebugFPSText.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/debug/DebugFPSText.cc	(revision 1619)
+++ code/branches/hud/src/orxonox/overlays/debug/DebugFPSText.cc	(revision 1619)
@@ -0,0 +1,54 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "DebugFPSText.h"
+#include <OgreTextAreaOverlayElement.h>
+#include "core/CoreIncludes.h"
+#include "GraphicsEngine.h"
+#include "util/Convert.h"
+
+namespace orxonox
+{
+    CreateFactory(DebugFPSText);
+
+    DebugFPSText::DebugFPSText()
+    {
+        RegisterObject(DebugFPSText);
+    }
+
+    DebugFPSText::~DebugFPSText()
+    {
+    }
+
+    void DebugFPSText::tick(float dt)
+    {
+        float fps = GraphicsEngine::getSingleton().getAverageFPS();
+        this->text_->setCaption(this->getCaption() + convertToString(fps));
+    }
+}
Index: code/branches/hud/src/orxonox/overlays/debug/DebugFPSText.h
===================================================================
--- code/branches/hud/src/orxonox/overlays/debug/DebugFPSText.h	(revision 1619)
+++ code/branches/hud/src/orxonox/overlays/debug/DebugFPSText.h	(revision 1619)
@@ -0,0 +1,51 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _DebugFPSText_H__
+#define _DebugFPSText_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "overlays/OverlayText.h"
+#include "objects/Tickable.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport DebugFPSText : public OverlayText, public Tickable
+    {
+    public:
+        DebugFPSText();
+        ~DebugFPSText();
+
+    private:
+        void tick(float dt);
+
+    private:
+    };
+}
+#endif /* _DebugFPSText_H__ */
Index: code/branches/hud/src/orxonox/overlays/debug/DebugRTRText.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/debug/DebugRTRText.cc	(revision 1619)
+++ code/branches/hud/src/orxonox/overlays/debug/DebugRTRText.cc	(revision 1619)
@@ -0,0 +1,54 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "DebugRTRText.h"
+#include <OgreTextAreaOverlayElement.h>
+#include "core/CoreIncludes.h"
+#include "util/Convert.h"
+#include "GraphicsEngine.h"
+
+namespace orxonox
+{
+    CreateFactory(DebugRTRText);
+
+    DebugRTRText::DebugRTRText()
+    {
+        RegisterObject(DebugRTRText);
+    }
+
+    DebugRTRText::~DebugRTRText()
+    {
+    }
+
+    void DebugRTRText::tick(float dt)
+    {
+        float rtr = GraphicsEngine::getSingleton().getAverageRTR();
+        this->text_->setCaption(this->getCaption() + convertToString(rtr));
+    }
+}
Index: code/branches/hud/src/orxonox/overlays/debug/DebugRTRText.h
===================================================================
--- code/branches/hud/src/orxonox/overlays/debug/DebugRTRText.h	(revision 1619)
+++ code/branches/hud/src/orxonox/overlays/debug/DebugRTRText.h	(revision 1619)
@@ -0,0 +1,49 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _DebugRTRText_H__
+#define _DebugRTRText_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "overlays/OverlayText.h"
+#include "objects/Tickable.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport DebugRTRText : public OverlayText, public Tickable
+    {
+    public:
+        DebugRTRText();
+        ~DebugRTRText();
+
+    private:
+        void tick(float dt);
+    };
+}
+#endif /* _DebugRTRText_H__ */
Index: code/branches/hud/src/orxonox/overlays/debug/HUDFPSText.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/debug/HUDFPSText.cc	(revision 1618)
+++ 	(revision )
@@ -1,54 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-#include "OrxonoxStableHeaders.h"
-#include "HUDFPSText.h"
-#include <OgreTextAreaOverlayElement.h>
-#include "core/CoreIncludes.h"
-#include "GraphicsEngine.h"
-#include "util/Convert.h"
-
-namespace orxonox
-{
-    CreateFactory(HUDFPSText);
-
-    HUDFPSText::HUDFPSText()
-    {
-        RegisterObject(HUDFPSText);
-    }
-
-    HUDFPSText::~HUDFPSText()
-    {
-    }
-
-    void HUDFPSText::tick(float dt)
-    {
-        float fps = GraphicsEngine::getSingleton().getAverageFPS();
-        this->text_->setCaption(this->getCaption() + convertToString(fps));
-    }
-}
Index: code/branches/hud/src/orxonox/overlays/debug/HUDFPSText.h
===================================================================
--- code/branches/hud/src/orxonox/overlays/debug/HUDFPSText.h	(revision 1618)
+++ 	(revision )
@@ -1,51 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-#ifndef _HUDFPSText_H__
-#define _HUDFPSText_H__
-
-#include "OrxonoxPrereqs.h"
-
-#include "overlays/OverlayText.h"
-#include "objects/Tickable.h"
-
-namespace orxonox
-{
-    class _OrxonoxExport HUDFPSText : public OverlayText, public Tickable
-    {
-    public:
-        HUDFPSText();
-        ~HUDFPSText();
-
-    private:
-        void tick(float dt);
-
-    private:
-    };
-}
-#endif /* _HUDFPSText_H__ */
Index: code/branches/hud/src/orxonox/overlays/debug/HUDRTRText.cc
===================================================================
--- code/branches/hud/src/orxonox/overlays/debug/HUDRTRText.cc	(revision 1618)
+++ 	(revision )
@@ -1,54 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-#include "OrxonoxStableHeaders.h"
-#include "HUDRTRText.h"
-#include <OgreTextAreaOverlayElement.h>
-#include "core/CoreIncludes.h"
-#include "util/Convert.h"
-#include "GraphicsEngine.h"
-
-namespace orxonox
-{
-    CreateFactory(HUDRTRText);
-
-    HUDRTRText::HUDRTRText()
-    {
-        RegisterObject(HUDRTRText);
-    }
-
-    HUDRTRText::~HUDRTRText()
-    {
-    }
-
-    void HUDRTRText::tick(float dt)
-    {
-        float rtr = GraphicsEngine::getSingleton().getAverageRTR();
-        this->text_->setCaption(this->getCaption() + convertToString(rtr));
-    }
-}
Index: code/branches/hud/src/orxonox/overlays/debug/HUDRTRText.h
===================================================================
--- code/branches/hud/src/orxonox/overlays/debug/HUDRTRText.h	(revision 1618)
+++ 	(revision )
@@ -1,49 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *                    > www.orxonox.net <
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Reto Grieder
- *   Co-authors:
- *      ...
- *
- */
-
-#ifndef _HUDRTRText_H__
-#define _HUDRTRText_H__
-
-#include "OrxonoxPrereqs.h"
-
-#include "overlays/OverlayText.h"
-#include "objects/Tickable.h"
-
-namespace orxonox
-{
-    class _OrxonoxExport HUDRTRText : public OverlayText, public Tickable
-    {
-    public:
-        HUDRTRText();
-        ~HUDRTRText();
-
-    private:
-        void tick(float dt);
-    };
-}
-#endif /* _HUDRTRText_H__ */